{-# LANGUAGE DeriveGeneric #-}
{-# LANGUAGE DuplicateRecordFields #-}
{-# LANGUAGE NamedFieldPuns #-}
{-# LANGUAGE OverloadedStrings #-}
{-# LANGUAGE RecordWildCards #-}
{-# LANGUAGE StrictData #-}
{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}
{-# OPTIONS_GHC -fno-warn-unused-matches #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.AppSync.Types.PipelineConfig
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.AppSync.Types.PipelineConfig where

import qualified Amazonka.Core as Core
import qualified Amazonka.Core.Lens.Internal as Lens
import qualified Amazonka.Data as Data
import qualified Amazonka.Prelude as Prelude

-- | The pipeline configuration for a resolver of kind @PIPELINE@.
--
-- /See:/ 'newPipelineConfig' smart constructor.
data PipelineConfig = PipelineConfig'
  { -- | A list of @Function@ objects.
    functions :: Prelude.Maybe [Prelude.Text]
  }
  deriving (Prelude.Eq, Prelude.Read, Prelude.Show, Prelude.Generic)

-- |
-- Create a value of 'PipelineConfig' with all optional fields omitted.
--
-- Use <https://hackage.haskell.org/package/generic-lens generic-lens> or <https://hackage.haskell.org/package/optics optics> to modify other optional fields.
--
-- The following record fields are available, with the corresponding lenses provided
-- for backwards compatibility:
--
-- 'functions', 'pipelineConfig_functions' - A list of @Function@ objects.
newPipelineConfig ::
  PipelineConfig
newPipelineConfig =
  PipelineConfig' {functions = Prelude.Nothing}

-- | A list of @Function@ objects.
pipelineConfig_functions :: Lens.Lens' PipelineConfig (Prelude.Maybe [Prelude.Text])
pipelineConfig_functions = Lens.lens (\PipelineConfig' {functions} -> functions) (\s@PipelineConfig' {} a -> s {functions = a} :: PipelineConfig) Prelude.. Lens.mapping Lens.coerced

instance Data.FromJSON PipelineConfig where
  parseJSON =
    Data.withObject
      "PipelineConfig"
      ( \x ->
          PipelineConfig'
            Prelude.<$> (x Data..:? "functions" Data..!= Prelude.mempty)
      )

instance Prelude.Hashable PipelineConfig where
  hashWithSalt _salt PipelineConfig' {..} =
    _salt `Prelude.hashWithSalt` functions

instance Prelude.NFData PipelineConfig where
  rnf PipelineConfig' {..} = Prelude.rnf functions

instance Data.ToJSON PipelineConfig where
  toJSON PipelineConfig' {..} =
    Data.object
      ( Prelude.catMaybes
          [("functions" Data..=) Prelude.<$> functions]
      )
